<?php

class ome_mdl_reship extends dbeav_model{
    //是否有导出配置
    var $has_export_cnf = true;

    var $export_name = '退换货单';

    var $has_many = array(
       'reship_items' => 'reship_items'
    );
    //所用户信息
    static $__USERS = null;
    var $defaultOrder = array('t_begin DESC,reship_id DESC');

    var $is_check = array(
        0 => '未审核',
        1 => '审核成功',
        2 => '审核失败',
        3 => '收货成功',
        4 => '拒绝收货',
        5 => '拒绝',
        6 => '补差价',
        7 => '完成',
        8 => '质检通过',
        9 => '拒绝质检',
        10 => '质检异常',
      );
    private $expert_flag= false;
    #售后类型
    private $return_type = array (
            'return' => '退货',
            'change' => '换货',
            'refuse' => '拒收退货'
    );

    public function _filter($filter,$tableAlias=null,$baseWhere=null){

        if (isset($filter['order_bn'])){
            $orderObj = $this->app->model("orders");
            $rows = $orderObj->getList('order_id',array('order_bn|head'=>$filter['order_bn']));
            $orderId[] = 0;
            foreach($rows as $row){
                $orderId[] = $row['order_id'];
            }
            $archive_ordObj = kernel::single('archive_interface_orders');

            $archorder = $archive_ordObj->getOrder_list(array('order_bn'=>$filter['order_bn']),'order_id');
            foreach ($archorder as $arc ) {
                $orderId[] = $arc['order_id'];
            }
            $where .= '  AND order_id IN ('.implode(',', $orderId).')';
            unset($filter['order_bn']);

        }

        if (isset($filter['bn'])) {
            $reshipItemModel = $this->app->model('reship_items');
            $rows = $reshipItemModel->getList('DISTINCT reship_id',array('bn|head'=>$filter['bn']));
            $reship_ids = array(0);
            foreach ($rows as $row) {
                $reship_ids[] = $row['reship_id'];
            }
            $where .=' AND reship_id IN('.implode(',',$reship_ids).')';
            unset($filter['bn']);
        }
        if (isset($filter['return_type']) && $filter['return_type']=='tmallchange'){
            $where.=" AND source='matrix' && shop_type='tmall' AND return_type='change'";
            unset($filter['return_type']);
        }

        if (isset($filter['return_bn'])){
            $return_detail = $this->db->selectrow("SELECT return_id FROM sdb_ome_return_product WHERE return_bn='".$filter['return_bn']."'");
            $where.=" AND return_id=".$return_detail['return_id'];
            unset($filter['return_bn']);
        }
        return parent::_filter($filter,$tableAlias,$baseWhere).$where;
    }

    /*
     * 获取退货单明细列表
     *
     * @param int $order_id 订单id
     *
     * @return array
     */
    function getItemList($reship_id){
        $reship_items = array();
        $items = $this->dump($reship_id,"reship_id",array("reship_items"=>array("*")));
        if($items['reship_items']){
            $reship_items = $items['reship_items'];
        }

        return $reship_items;
    }

    /*
     * 生成退货单号
     *
     *
     * @return 退货单号
     */
    function gen_id(){
        $i = rand(0,9999);
        do{
            if(9999==$i){
                $i=0;
            }
            $i++;
            $reship_bn = date("YmdH").'13'.str_pad($i,6,'0',STR_PAD_LEFT);
            $row = $this->db->selectrow('select reship_bn from sdb_ome_reship where reship_bn =\''.$reship_bn.'\'');
        }while($row);
        return $reship_bn;
    }

    function searchOptions(){
        $parentOptions = parent::searchOptions();
        $childOptions = array(
            'order_bn'=>app::get('base')->_('订单号'),
            'return_bn'=>'售后申请单号',
            'bn' => '货号',
        );
        return $Options = array_merge($parentOptions,$childOptions);
    }

    //创建/编辑 退换单
    function create_treship($adata,&$msg){

        //组织新增或者编辑数据
        if($adata['delivery_id']) {
            if ($adata['source'] == 'archive'){
                $archive_delObj = kernel::single('archive_interface_delivery');
                $delivery = $archive_delObj->getDelivery(array('delivery_id'=>$adata['delivery_id']),'*');
            }else{
                $oDelivery = $this->app->model('delivery');
                $delivery = $oDelivery->dump($adata['delivery_id']);
            }
        }
        if ($adata['branch_id']) {
            $branch_id = $adata['branch_id'];
        }else{
            if ($adata['return']['branch_id']) {
                $return_branch = $adata['return']['branch_id'];
                $branch_id = current($return_branch);
            }
        }
        //操作员信息
        $opInfo = kernel::single('ome_func')->getDesktopUser();
        $sdf_data = array(
            'return_id'        => $adata['return_id'],
            'reship_id'        => $adata['reship_id'],
            'order_id'         => $adata['order_id'],
            'member_id'        => $adata['member_id'],
            'return_logi_name' => $adata['return_logi_name'],
            'return_type'      => $adata['return_type'],
            'return_logi_no'   => $adata['return_logi_no'],
            'logi_name'        => $adata['logi_name'],
            'logi_no'          => $adata['logi_no'],
            'logi_id'          => $adata['logi_id'],
            'ship_name'        => $adata['ship_name'],
            'ship_area'        => $adata['ship_area'],
            'delivery'         => $adata['delivery'],
            'ship_addr'        => $adata['ship_addr'],
            'ship_zip'         => $adata['ship_zip'],
            'ship_tel'         => $adata['ship_tel'],
            'ship_email'       => $adata['ship_email'],
            'ship_mobile'      => $adata['ship_mobile'],
            'memo'             => $adata['memo'],
            'status'           => 'ready',
            'op_id'            => $opInfo['op_id'],
            'logi_id'          => $adata['logi_id'],                                                        //物流ID
            'is_protect'       => ($adata['is_protect'] ? $adata['is_protect'] : $delivery['is_protect']),  //是否报价
            'return'           => $adata['return'],
            'change'           => $adata['change'],
            'reship_bn'        => ( $adata['reship_bn'] ? $adata['reship_bn'] : $this->gen_id() ),
            'shop_id'          => ( $adata['shop_id'] ? $adata['shop_id'] : $delivery['shop_id'] ),
            'problem_id'       => $adata['problem_type'][0],
            'branch_id'        => $branch_id,
            'tmoney'          =>  $adata['tmoney'],
            'change_amount'   =>  floatval($adata['change_amount']),
        );
        if(empty($sdf_data['shop_id'])) {
            $msg = '店铺信息为空!'; return false;
        }

	   if ($adata['source']) $sdf_data['source'] = $adata['source'];
        if ($adata['return_type'] == 'change') {
            $sdf_data['changebranch_id'] = $adata['changebranch_id'] ? $adata['changebranch_id'] : $branch_id;
        }
        if ($adata['source'] == 'archive') {
            $sdf_data['archive'] = '1';
            $sdf_data['source'] = 'archive';
        }
        $oShop = $this->app->model ( 'shop' );
        $sdf_data['shop_type'] = $oShop->getShoptype($sdf_data['shop_id']);
        if($sdf_data['reship_id']) {//编辑
            //判断是否为待确认，换货改为退货类型
            $reship_detail = $this->app->model('reship')->dump($sdf_data['reship_id'],'return_type,is_check,need_sv,changebranch_id');
            if ($reship_detail['return_type'] =='change' && $reship_detail['is_check']=='11' && $reship_detail['need_sv']=='true' && $sdf_data['return_type']=='return') {
                //库存管控 退换货单回传 可能出现is_check 11 释放冻结库存(目前只有电商仓有)
                $storeManageLib = kernel::single('ome_store_manage');
                $storeManageLib->loadBranch(array('branch_id'=>$adata['changebranch_id']));
                $params_stock = array(
                        "params" => $adata,
                        "node_type" => "editChangeToReturn",
                );
                $storeManageLib->processBranchStore($params_stock, $err_msg);
            }
            $add_operation = '编辑';
        }else{//新建
            $sdf_data['t_begin'] = time();
            $add_operation = '新建';
        }
        $return = $sdf_data['return'];
        if ($branch_id) {
            $return['branch_id'] = $branch_id;
        }
        $change = $sdf_data['change'];
        unset($sdf_data['return'],$sdf_data['change']);
        if ($adata['reship_id'] && $adata['return_type'] == 'change') {
          $oldchange = kernel::single('ome_return_rchange')->getChangelist($adata['reship_id'],$adata['changebranch_id']);
        }
        //新建/编辑reship
        if($this->save($sdf_data)){
            # 保存退换货单明细
            $oReship_items = $this->app->model('reship_items');
            $result = $this->save_product_items($return,$sdf_data['reship_id'],$oReship_items,'return',$sdf_data['return_id']);
            if ($result['status'] != 'succ') {
              $msg = $result['msg']; return false;
            }
            if ($sdf_data['return_type'] == 'change'){
                $change['shop_id'] = $sdf_data['shop_id'];
                $result = $this->save_product_items($change,$sdf_data['reship_id'],$oReship_items,'change');
                if ($result['status'] != 'succ') {
                    $msg = $result['msg']; return false;
                }
                //判断是否有货品删除
                if ($oldchange) {
                    $this->_deletechange_item($sdf_data['reship_id'],$change,$oldchange);
                }
            }

            # 操作日志
            $oOperation_log = $this->app->model('operation_log');
            $memo = $add_operation.'退换货单,单号为:'.$sdf_data['reship_bn'];
            $oOperation_log->write_log('reship@ome',$sdf_data['reship_id'],$memo);

            //存在相关的售后单 更新相关字段 为了售后问题类型的统计添加的字段(problem_id)，并且给该字段赋值
            if($sdf_data['return_id']){
                $oProduct = $this->app->model('return_product');
                $oProduct_problem_id = array(
                    'return_id'  => $sdf_data['return_id'],
                    'tmoney'     => $tmoney,
                    'problem_id' => $adata['problem_type'][0],
                );
                $oProduct->save($oProduct_problem_id);
            }

            $msg = $add_operation.'退换货单成功，请等待审核!';
            return $sdf_data['reship_bn'];
        }else{
            $msg = $add_operation.'退换货单失败.';
            return false;
        }
  }

  /**
   * 保存退货明细
   * 将退入，换出商品分别存入reship_items表中
   * @param array $param ,$type
   * @return void
   * @author
   **/
  function save_product_items($param,$reship_id,$object,$type = 'return',$return_id='')
  {
      $rs = array('status'=>'succ','msg'=>'保存成功！');

    $opInfo = kernel::single('ome_func')->getDesktopUser();
    $oReturn_items = $this->app->model('return_product_items');

    # 保存退货及已有的换货明细
    if ($type == 'return' && $param['goods_bn'] && is_array($param['goods_bn']) )
    {
      $reship_orginal_items = array();
      foreach ($param['goods_bn'] as $key => $bn) {
        $item = array(
          'reship_id'    => $reship_id,
          'product_name' => $param['goods_name'][$bn],
          'bn'           => $bn,
          'num'          => $param['num'][$bn],
          'product_id'   => $param['product_id'][$bn],
          'price'        => $param['price'][$bn],
          'return_type'  => $type,
          //'branch_id'    => $param['branch_id'],
          'op_id'        => $opInfo['op_id'],
          'item_id'      => $param['item_id'][$bn],
        );
        if ($type == 'return') {
            $item['branch_id'] = $param['branch_id'];
        }else{
           $item['branch_id'] = $param['branch_id'][$bn];
        }
        $result = $object->save($item);
        if (!$result) {
          return array('status'=>'fail','msg'=>'插入退货商品【'.$bn.'】时失败！');
        }

        if ($type == 'return' && $return_id) {
          $updateData = array('num' => $item['num']);
          $updateFilter = array('return_id'=>$return_id,'product_id'=>$item['product_id']);
          $oReturn_items->update($updateData,$updateFilter);
        }

      }
    }

    # [换货]保存新增的商品
    $shipObj = app::get('ome')->model('reship_objects');
    $itemsObj = app::get('ome')->model('reship_items');

    if ($type=='change' && $param['objects'])
    {
        foreach ( $param['objects'] as $changeobj )
        {
            #销售物料层
            $obj    = array();
            $obj['reship_id'] = $reship_id;
            $obj['obj_type'] = $changeobj['obj_type'];
            $obj['product_id'] = $changeobj['product_id'];
            $obj['bn'] = $changeobj['bn'];
            $obj['product_name'] = $changeobj['name'];
            $obj['price'] = $changeobj['price'];
            $obj['num'] = $changeobj['num'];

            if ($changeobj['item_id'])
            {
                $obj['obj_id'] = $changeobj['item_id'];
            }
            $shipObj->save($obj);
            //新增或者编辑都会存在主键id 不存在说明obj表数据异常
            if(!$obj["obj_id"])
            {
                return array('status'=>'fail','msg'=>'插入换货销售物料号【'. $changeobj['bn'] .'】时失败！');
            }
            if ($changeobj['obj_type'] == 'pkg'){
                $salesMLib = kernel::single('material_sales_material');
                $salesMInfo = $salesMLib->getSalesMByBn($param['shop_id'],$changeobj['bn']);
                $basicMInfos = $salesMLib->getBasicMBySalesMId($salesMInfo['sm_id']);
                $salesMLib->calProSaleMPriceByRate($changeobj['price'], $basicMInfos);
                $arrBn = array();
                foreach($basicMInfos as $v){

                  $arrBn[$v['material_bn']] = $v['rate_price'];
                }

            }
            foreach ($changeobj['items'] as $item)
            {
                $item['reship_id']      = $reship_id;
                $item['obj_type']       = $changeobj['obj_type'];

                $item['product_id']     = $item['bm_id'];
                $item['bn']             = $item['material_bn'];
                $item['product_name']   = $item['material_name'];
                $item['num']            = $item['change_num'];
                $item['return_type']    = 'change';

                #操作人
                $item['op_id']    = $opInfo['op_id'];

                #销售物料的价格
                $item['price']    = $changeobj['obj_type'] == 'pkg' ? $arrBn[$item['material_bn']] : $changeobj['price'];

                #关联sdb_ome_reship_objects
                $item['obj_id']    = $obj['obj_id'];

                #判断插入还是更新
                $item_detail    = $itemsObj->dump(array('obj_id'=>$item['obj_id'], 'bn'=>$item['bn']), 'item_id');
                if ($item_detail['item_id'])
                {
                    $item['item_id']    = $item_detail['item_id'];
                }

                $itemsObj->save($item);
            }
        }
    }

    return $rs;
  }


    /**
     * 获取售后明细
     *
     * @return void
     * @author
     **/
    function getReshipItems($reship_id)
    {
      $Oreships = $this->app->model('reship_items');
      $oOrders = $this->app->model('orders');
      $Oreship_items = $Oreships->getList('*',array('reship_id'=>$reship_id),0,1);
      $reshipitems = $this->dump(array('reship_id'=>$reship_id),'*');
      $orders = $oOrders->dump($reshipitems['order_id'],'order_bn');
      if (!$orders['order_bn']) {

        $archive_ordObj = kernel::single('archive_interface_orders');
        $orders = $archive_ordObj->getOrders(array('order_id'=>$reshipitems['order_id']),'order_bn');
      }
      $reshipitems['order_bn'] =$orders['order_bn'];
      $reshipitems['items'][] = $Oreship_items[0];
      return $reshipitems;
    }

   /**
    * 获取审核发货单信息
    *
    * @return void
    * @author
    **/
   function getCheckinfo($reship_id,$transform=true)
   {
       $basicMaterialLib    = kernel::single('material_basic_material');
       $libBranchProduct    = kernel::single('ome_branch_product');

        $oOrders = $this->app->model ('orders');

        $oMember = $this->app->model('members');
        $oDc = $this->app->model('dly_corp');
        $oReship_item = $this->app->model ( 'reship_items' );
        $Oreturn_products = $this->app->model('return_product');
        $reship_data = $this->dump(array('reship_id'=>$reship_id));
        $reship_data['return_logi_id'] = $reship_data['return_logi_name'];
       // $dc_data = $oDc->dump($reship_data['return_logi_name']);
        $order_data = $oOrders->dump($reship_data['order_id']);
        $archive_ordObj = kernel::single('archive_interface_orders');
        if ($reship_data['archive']=='1' || ($reship_data['source'] && in_array($reship_data['source'],array('archive')))) {
            $oReship_item = $oOrders = kernel::single('archive_interface_orders');
            $order_data = $archive_ordObj->getOrders(array('order_id'=>$reship_data['order_id']),'*');
            unset($order_data['source']);
        }
        unset($order_data['source'],$order_data['archive']);
        $member = $oMember->dump(array('member_id'=>$order_data['member_id']));
        $oBranch=$this->app->model('branch');
        if($transform){
           //$reship_data['return_logi_name'] = $dc_data['name'];
           $rd = explode(':', $reship_data['ship_area']);
           if($rd[1]){
             $reship_data['ship_area'] = str_replace('/', '-', $rd[1]);
           }
        }

        $reship_item = $this->getItemList($reship_id);
        $reship_data = array_merge($reship_data,$order_data);
        $rp = $Oreturn_products->dump(array('return_id'=>$reship_data['return_id']));
        $reship_data['title'] = $rp['title'];
        $reship_data['member_id'] = $member['account']['uname'];
        $reship_data['content'] = $rp['content'];
        $reship_data['return_memo'] = $rp['memo'];
        if ($reship_data['branch_id']) {
            $branchs = $oBranch->db->selectrow("SELECT name,branch_id FROM sdb_ome_branch WHERE branch_id=".$reship_data['branch_id']."");
            $reship_data['branch_name'] = $branchs['name'];
            unset($branchs);
        }
        if($reship_item){
          $recover = array(); $tmoney = 0;

          foreach ($reship_item as $key => $value) {
            $branchs = $oBranch->db->selectrow("SELECT name,branch_id FROM sdb_ome_branch WHERE branch_id=".$value['branch_id']."");
            $reship_item[$key]['branch_id'] = $branchs['branch_id'];
            $reship_item[$key]['branch_name'] = $branchs['name'];

            $product    = $basicMaterialLib->getBasicMaterialExt($value['product_id']);

            $reship_item[$key]['spec_info'] = $product['specifications'];

            if($value['return_type'] == 'return'){
                 $refund = $oReship_item->Get_refund_count( $reship_data['order_id'], $value['bn'] ,$reship_id);
                 $reship_item[$key]['effective'] = $refund;
                 $recover['return'][] = $reship_item[$key];
                 $recover['total_return_filter'][] = $product['bm_id'];

                 # 计算应退金额
                 $tmoney += $value['price'] * $value['num'];
            }else{
                //作判断如果是待确认时,审核剩余数量不减冻结
                $refund=0;
                 $refund = $libBranchProduct->get_product_store( $value['branch_id'],$value['product_id'] );
                 if ($reship_data['is_check'] == '11' && $value['return_type'] == 'change') {
                    $refund+=$value['num'];
                }
                 $reship_item[$key]['effective'] = $refund;
                 $recover['change'][] = $reship_item[$key];
                 $recover['total_change_filter'][] = $product['bm_id'];
            }
          }

          $reship_data = array_merge($reship_data,$recover);
          //$reship_data['tmoney'] = ($reship_data['tmoney']!='0.000')?$reship_data['tmoney']:$reship_data['total_amount'];
          $reship_data['tmoney'] = kernel::single('eccommon_math')->getOperationNumber($tmoney);

          $reship_data['total_return_filter'] = implode(',', $reship_data['total_return_filter']);
          $reship_data['total_change_filter'] = implode(',', $reship_data['total_change_filter']);
        }

        return $reship_data;
   }


    public function modifier_return_logi_name( $val ) {
        $oDc = $this->app->model('dly_corp');
        $dc_data = $oDc->dump($val);
        if($dc_data['name']){;
          return $dc_data['name'];
        }else{
          return $val;
        }
    }


    /**
     * 保存入库单信息
     * status 状态：
     *       5: 拒绝 生成一张发货单 商品明细为退入商品中的商品信息
     *       6：补差价，生成一张未付款的支付单
     *       8: 操作完成
     * @return void
     * @author
     **/
    public function saveinfo($reship_id,$data,$status,$api=false){

        $memo = '';
        $reship_num=0;//退货单数量
        $order_num=0;//退货单数量
        $oDc = $this->app->model('dly_corp');
        $Oreturn_products = $this->app->model('return_product');
        $reshipinfo = $this->dump(array('reship_id'=>$reship_id),'*');
        $oReship_items = $this->app->model('reship_items');
        $reship_items = $oReship_items->getList('*',array('reship_id'=>$reship_id));
        $reshipinfo['return_logi_id'] = $reshipinfo['return_logi_id'];
        $dc_data = $oDc->dump($reshipinfo['return_logi_name']);
        $reshipinfo['return_logi_name'] = $dc_data['name'];

        switch ($status){
          case '6':
            $aData['return_id'] = $data['return_id'];
            $aData['reship_id'] = $reship_id;
            $aData['memo'] = $data['dealmemo'];
            $aData['money'] = $data['totalmoney'];
            $aData['tmoney']=$data['tmoney'];
            $aData['bmoney']=$data['bmoney'];
            $aData['is_check']='6';
            //补差价
            //增加售后日志
            $memo.= '售后服务：补差价(￥'.-(float)$data['totalmoney'].')';
            $this->update($aData,array('reship_id'=>$reship_id));
            if($reshipinfo['return_id']){
                unset($aData['reship_id'],$aData['is_check']);
                $aData['status']='8';
                $Oreturn_products->update($aData,array('return_id'=>$reshipinfo['return_id']));
            }

          break;
        }



        /*日志描述start*/
        if($reship_num!=0){
            $memo.='   生成了'.$reship_num.'张退货单,';
        }
        if($order_num!=0){
            $memo.='   生成了'.$order_num.'张订单'.$order_memo;
        }
        $oOperation_log = $this->app->model('operation_log');//写日志
        if($data['return_id']){
           $oOperation_log->write_log('return@ome',$data['return_id'],$memo);
        }
        $oOperation_log->write_log('reship@ome',$reship_id,$memo);
        return true;
    }

  /*
   * 生成发货单
   * @param array $adata
   * return int
   */
   function create_delivery($adata)
   {
       $oDelivery = $this->app->model('delivery');

       $delivery_sdf=array(
           'branch_id'=>$adata['branch_id'],
           'is_protect'=>$adata['is_protect'],
           'delivery' => $adata['delivery'],
           'logi_id'=>$adata['logi_id'],
           'logi_name'=>$adata['logi_name'],
           'op_id'=>kernel::single('desktop_user')->get_id(),
           'create_time'=>time(),
           'delivery_cost_actual' => $adata['delivery_cost_actual'] ? $adata['delivery_cost_actual'] : 0,
           'type'=>'reject',
           'delivery_items' =>$adata['delivery_items'],
        );
       $adata['ship_area'] = str_replace('-', '/', $adata['ship_area']);
       kernel::single('eccommon_regions')->region_validate($adata['ship_area']);
        $ship_info=array(
           'name' => $adata['ship_name'],
           'area' => $adata['ship_area'],
           'addr' => $adata['ship_addr'],
           'zip' => $adata['ship_zip'],
           'telephone' =>$adata['ship_tel'],
           'mobile' =>$adata['ship_mobile'],
           'email' => $adata['ship_email']
          );

        $result=$oDelivery->addDelivery($adata['order_id'],$delivery_sdf,$ship_info);
        $delivery_bn = $oDelivery->dump(array('delivery_id'=>$result),'delivery_bn');
        $delivery_bn = $delivery_bn['delivery_bn'];

        return $delivery_bn;
   }

   /*
    *  售后服务换货生成订单
    * @param $reshipinfo 退换货单信息,退换货单商品信息
    * return $new_order_id
    */
   function create_order($reshipinfo){
        $oOrder = $this->app->model('orders');

        #获取换货明细
        $rchangeObj = kernel::single('ome_return_rchange');
        $extendObj = app::get('ome')->model('order_extend');//orig_reship_id
        $extend_detail = $extendObj->dump(array('orig_reship_id'=>$reshipinfo['reship_id']),'order_id');
        if ($extend_detail){
          return false;
        }
        $reship_items = $rchangeObj->getChangelist($reshipinfo['reship_id'],$reshipinfo['changebranch_id']);

        $order_bn = $oOrder->gen_id();
         if ($reshipinfo['source'] == 'archive') {
            $archive_ordObj = kernel::single('archive_interface_orders');
            $Order_detail = $archive_ordObj->getOrders(array('order_id'=>$reshipinfo['order_id']),'*');
        }else{
            $Order_detail = $oOrder->dump($reshipinfo['order_id']);
        }

        if($reshipinfo['ship_area']!=''){
           $reshipinfo['ship_area'] = str_replace('-', '/', $reshipinfo['ship_area']);
           kernel::single('eccommon_regions')->region_validate($reshipinfo['ship_area']);
           $ship_area = $reshipinfo['ship_area'];
        }else{
           $ship_area = $Order_detail['consignee']['area'];
        }

        $order_sdf = array(
           'order_bn'=>$order_bn,
           'member_id'=>$Order_detail['member_id'],
            'currency'=>'CNY',
            'title'=>$tostr,
            'createtime'=>time(),
            'last_modified'=>time(),
            'confirm'=>'N',
            'status'=>'active',
            'pay_status'=>'0',
            'ship_status'=>'0',
            'is_delivery'=>'N',
            'shop_id'=>$reshipinfo['shop_id'],
            'itemnum'=>$itemnum,
            'relate_order_bn'=>$Order_detail['order_bn'],
            'shipping'=>array(
                'shipping_id'=>$Order_detail['shipping']['shipping_id'],
                'is_cod'=>'false',
                'shipping_name'=>$Order_detail['shipping']['shipping_name'],
                'cost_shipping'=>$reshipinfo['cost_freight_money'],
                'is_protect'=>$Order_detail['shipping']['is_protect'],
                'cost_protect'=>0,
            ),
           'consignee'=>array(
               'name'=>$reshipinfo['ship_name']  ? $reshipinfo['ship_name'] :$Order_detail['consignee']['name'],
               'addr'=>($reshipinfo['ship_addr']!='')?$reshipinfo['ship_addr']:$Order_detail['consignee']['addr'],
               'zip'=>($reshipinfo['ship_zip']!='')?$reshipinfo['ship_zip']:$Order_detail['consignee']['zip'],
               'telephone'=>($reshipinfo['ship_tel']!='')?$reshipinfo['ship_tel']:$Order_detail['consignee']['telephone'],
               'mobile'=>($reshipinfo['ship_mobile']!='')?$reshipinfo['ship_mobile']:$Order_detail['consignee']['mobile'],
               'email'=>($reshipinfo['ship_email']!='')?$reshipinfo['ship_email']:$Order_detail['consignee']['email'],
               'area'=>$ship_area,
               'r_time'=>$Order_detail['consignee']['r_time'],
            ),
            'mark_type' => 'b1',
            'source' => 'local',
            'createway' => 'after',
        );
        $mark_text = array(
          array(
            'op_name' => 'system',
            'op_time' => time(),
            'op_content' => '售后换货，创建的换出订单。要求换货的订单('.$Order_detail['order_bn'].')',
          ),
        );
        if ($reshipinfo['memo']) {
          $user = app::get('desktop')->model('users')->getList('name',array('user_id' => $reshipinfo['op_id']),0,1);
          $mark_text[] = array(
            'op_name' => $user[0]['name'],
            'op_time' => time(),
            'op_content' => $reshipinfo['memo'],
          );
        }
        $order_sdf['mark_text'] = $mark_text;

        #[销售物料层]格式化订单明细
        $item_cost = 0;
        foreach ( $reship_items as &$items )
        {
            unset($items['reship_id'],$items['type'],$items['branch_id'],$items['item_id'],$items['obj_id']);

            if(($items['item_type'] != 'pkg') && ($items['item_type'] != 'pkg'))
            {
                $items['item_type']    = 'goods';
            }

            $items['obj_alias']   = $items['obj_type'] = $items['item_type'];
            $items['goods_id']    = $items['item_id'];
            $items['name']        = $items['product_name'];
            $items['quantity']    = $items['num'];
            $items['amount']      = $items['sale_price'] = $items['num'] * $items['price'];

            #基础物料层
            $order_items    = array();
            foreach ($items['items'] as $key_i => $item_row)
            {
                #注销无用变量
                unset($item_row['item_id'], $item_row['obj_id'], $item_row['branch_id'], $item_row['number'], $item_row['quantity']);

                #注销基础物料变量
                unset($item_row['sm_id'], $item_row['bm_id'], $item_row['material_name'], $item_row['material_bn']);

                $item_row['goods_id']    = $items['goods_id'];

                $item_row['name']        = $item_row['product_name'];
                $item_row['quantity']    = $item_row['change_num'];//换货数量
                $item_row['amount']      = $item_row['sale_price'] = $item_row['change_num'] * $item_row['price'];

                $order_items[]    = $item_row;
            }

            $items['order_items']    = $order_items;

            #商品总金额
            $item_cost    += $items['amount'];
        }

        $order_sdf['order_objects']    = $reship_items;


       $order_sdf['total_amount'] = $item_cost+$order_sdf['shipping']['cost_shipping']+$order_sdf['shipping']['cost_protect'];
       $order_sdf['final_amount'] = $order_sdf['total_amount'];

       $order_sdf['cost_item']    = $item_cost;

       $result =  $this->app->model('orders')->create_order($order_sdf);

       if ($result){
          //更新退货单上状态
          $reshipObj = app::get('ome')->model('reship');
          $reshipObj->update(array('change_order_id'=>$order_sdf['order_id'],'change_status'=>'1'),array('reship_id'=>$reshipinfo['reship_id']));
          kernel::single('ome_service_aftersale')->returngoods_agree($reshipinfo['return_id']);
          $extend_data = array('orig_reship_id'=>$reshipinfo['reship_id'],'order_id'=>$order_sdf['order_id']);
          app::get('ome')->model('order_extend')->save($extend_data);
          //原订单上新增换出订单备注
          if($Order_detail['mark_text']) $oldmemo= unserialize($Order_detail['mark_text']);
          $memo = array();
          $memo[] = array('op_name'=>'system', 'op_time'=>date('Y-m-d H:i:s',time()), 'op_content'=>'进行售后换货，创建的换出订单:'.$order_sdf['order_bn']);
          if ($oldmemo){
              foreach($oldmemo as $k=>$v){
                $memo[] = $v;
              }
          }


          if ($memo){
              $mark_text = serialize($memo);

              $oOrder->update(array('mark_text'=>$mark_text),array('order_id'=>$Order_detail['order_id']));
          }
       }
       return  $result ? $order_sdf : false;
   }

    /*
     * 数据验证
     * param $data 需校验的参数
     * param $v_msg 返回信息
     */
    function validate($data,&$v_msg)
    {
        $v_msg = '';
        $type_return = $data['return'];
        $type_change = $data['change'];

        $return_c = count($type_return['goods_bn']);
        if( $return_c == 0 ){
          $v_msg = '请选择至少一个退入商品。';
          return false;
        }

        if($data['return_type'] == 'change'&& (!$type_change['objects']) ){
            $v_msg = '请至少选择一个换出商品。';
          return false;
        }

        if ($data['return_type'] == 'change'){
            foreach($type_change['objects'] as $v_c){
                if ($v_c['product_id']<=0){
                    $v_msg = $v_c['bn'].'换货商品数据不完整!';
                    return false;
                }
            }
        }

        if($type_return['goods_bn']){
           foreach ($type_return['goods_bn'] as $key => $value) {
              if($type_return['effective'][$value] < 1){
                  $v_msg = '退入商品中货号为:'.$value.'商品申请数量小于0，申请被拒绝!';
                  return false;
              }
              if ($data['is_check'] == '11') {
                  if ($type_return['normal_num'][$value] > $type_return['effective'][$value]) {
                  $v_msg = '货号【'.$value.'】的入库数量超出可退入数量，申请被人拒绝!';
                  return false;
                  }
              }else{
                  if ($type_return['num'][$value] > $type_return['effective'][$value]) {
                  $v_msg = '货号【'.$value.'】的申请数量超出可退入数量，申请被人拒绝!';
                  return false;
                  }
              }

              if ($type_return['num'][$value]<=0) {
                  $v_msg = '货号【'.$value.'】的申请数量必须大于0!';
                  return false;
              }
           }
        }

        #数据验证([最终收货]提交时,不再检查库存,新建售后时已经检查过了)
        $libBranchProduct    = kernel::single('ome_branch_product');
        if($data['return_type'] == 'change' && $type_change['objects'] && $data['is_check'] != '11')
        {

            //换货的仓库
            $changebranch_id = $data['changebranch_id'];
            //判断是否是门店仓
            $store_id = kernel::single('ome_branch')->isStoreBranch($changebranch_id);

            #销售物料层
            foreach ($type_change['objects'] as $objects )
            {
                #基础物料层
                foreach ($objects['items'] as $item_key => $item)
                {
                    $bm_id         = $item['bm_id'];
                    $change_num    = $item['change_num'];#换货数量

                    if ($change_num < 1){
                        $v_msg = '换出商品中,基础物料为:['. $item['material_bn'] .']申请数量为0，申请被拒绝。';
                        return false;
                    }

                    //是否检查库存数 默认true（门店仓存在不管控库存的情况）
                    $check_stock = true;

                    #基础物料库存 [根据选择的换货仓库]获取基础物料库存
                    if($store_id){//门店仓
                        $arr_stock = kernel::single('o2o_return')->o2o_store_stock($changebranch_id,$bm_id);
                        $store_num = $arr_stock["store"]; //值可能会包括 "-" "x" 或 真实的库存数
                        if ($store_num == "x"){
                            $v_msg = '换出商品中,基础物料为:['. $item['material_bn'] .']与此门店仓无供货关系，申请被拒绝。';
                            return false;
                        }
                        if($store_num == "-"){//不管控库存。
                            $check_stock = false;
                        }
                    }else{//电商仓
                        $temp_store = $libBranchProduct->getAvailableStore($changebranch_id, array($bm_id));
                        $store_num = $temp_store[$bm_id];
                    }

                    if ($store_num < 1 && $check_stock){
                        $v_msg = '换出商品中,基础物料为:['. $item['material_bn'] .']实际的库存为0，申请被拒绝。';
                        return false;
                    }

                    if ($change_num > $store_num && $check_stock){
                        $v_msg = '换出商品中,基础物料为:['. $item['material_bn'] .']申请数量大于实际的库存。申请被拒绝。';
                        return false;
                    }
                }
            }
        }

        #  判断补差价 chenping
        if ($data['diff_order_bn']) {
          $order = $this->app->model('orders')->select()->columns('order_id')
                    ->where('order_bn=?',$data['diff_order_bn'])
                    ->where('pay_status=?','1')
                    ->where('ship_status=?','0')
                    ->where('status=?','active')
                    ->instance()->fetch_row();
          if (empty($order)) {
            $v_msg = '补差价订单有误!';
            return false;
          }
        }
        return true;
    }

    //质检成功后执行相应的操作
    function finish_aftersale($reship_id){
        $Oreturn_products = $this->app->model('return_product');
        $Oreship = $this->app->model('reship');
        $oOperation_log = $this->app->model('operation_log');
        $oRefund_apply = $this->app->model('refund_apply');

        //避免并发加判断
        $reship_detail = $Oreship->dump($reship_id,'status');
        if ($reship_detail['status'] == 'succ') {
            return false;
        }
        //先更新状态为成功
        $this->update(array('status'=>'succ'),array('reship_id'=>$reship_id));

        //获取退换货单主表数据
        $reshipinfo = $this->dump(array('reship_id'=>$reship_id),'*');

        //是否生成售后单
        $is_generate_aftersale = true;

        //满足条件 退换货单创建 API执行
        $this->request_reship_creat_api($reshipinfo['shop_id'],$reship_id);

        //是否归档
        $is_archive = kernel::single('archive_order')->is_archive($reshipinfo['source']);

        //订单明细退货处理
        $orders = $this->do_order_items_return($reshipinfo,$is_archive);

        //生成退款申请单
        $totalmoney = (float)$reshipinfo['totalmoney']; # 实际需要退款的金额
        //新建退款申请单时的申请退款金额
        $money = (float)$reshipinfo['tmoney']+(float)$reshipinfo['diff_money']+(float)$reshipinfo['bcmoney']-(float)$reshipinfo['bmoney'];
        if($money > 0){ //申请退款金额大于0时新建退款申请
            $refund_apply_bn = $oRefund_apply->gen_id();
            $refund_sdf = $this->create_refund_apply_record($refund_apply_bn,$reshipinfo,$money,$is_archive);
        }
        $reshipLib = kernel::single('ome_reship');
        if ($is_archive) {
            $reshipLib = kernel::single('archive_reship');
        }
        //判断是否要生成一张支付单
        if ($reshipinfo['diff_order_bn']) {//新增补差订单 发货状态改为已发货 并把状态回打给前端。
            kernel::single('ome_reship')->updatediffOrder($reshipinfo['diff_order_bn']);
        }
        $memo = '';
        if($reshipinfo['return_type'] =='change'){//换货
            if ($reshipinfo['change_order_id'] == 0 && $reshipinfo['change_status']=='0'){
                //这两个define是ome_freeze_stock_log表新增记录用
                define('FRST_TRIGGER_OBJECT_TYPE','订单：售后申请换货生成新订单');
                define('FRST_TRIGGER_ACTION_TYPE','ome_mdl_return_product：saveinfo');
                $change_order_sdf = $this->create_order($reshipinfo);
                if ($change_order_sdf) {
                    $memo .=' 生成了1张换货订单【'.$change_order_sdf['order_bn'].'】';
                    //库存管控 生成订单后释放库存
                    $storeManageLib = kernel::single('ome_store_manage');
                    $storeManageLib->loadBranch(array('branch_id'=>$reshipinfo['changebranch_id']));
                    $params_stock = array(
                            "params" => $reshipinfo,
                            "node_type" => "confirmReshipChange",
                    );
                    $storeManageLib->processBranchStore($params_stock, $err_msg);

                    //换出的订单金额
                    $change_total_amount = $change_order_sdf['total_amount'];
                    //换出的订单ID
                    $neworderid = $change_order_sdf['order_id'];
                }
            }else{
                $change_total_amount = $reshipinfo['change_amount'];
            }

            $pay_money = $money; //生成的换货订单支付金额
            $pay_status = '1'; //已支付
            if ($totalmoney == 0) {//如果实际退款金额为零,无需退款与支付
                if(!empty($refund_sdf)){ //退款申请完成，并产生退款单 走个已退款的流水
                    $reshipLib->createRefund($refund_sdf,$orders);
                }
            }elseif ($totalmoney<0) { //负数： 需客户再补钱的
                if(!empty($refund_sdf)){ //退款申请完成，并产生退款单 走个已退款的流水
                    $reshipLib->createRefund($refund_sdf,$orders);
                }
                $pay_status = '3'; //部分支付
            }elseif ($totalmoney>0) { //正数：需商家再补给客户
                $is_generate_aftersale = false;
                //更新为实际退款金额 需要退款
                if(!empty($refund_sdf)){
                    $memo .= $refund_sdf['memo'].'总退款金额大于换货订单总额，进行多余费用退款!';
                    $oRefund_apply->update(array("money"=>$totalmoney,"memo"=>$memo),array('refund_apply_bn'=>$refund_apply_bn));
                }
                //生成退款申请单（换出的订单金额） 后产生退款单 状态更新为已退款
                if($change_total_amount>0){ //申请退款金额大于0时新建退款申请
                    $refund_apply_bn = $oRefund_apply->gen_id();
                    $refund_sdf = $this->create_refund_apply_record($refund_apply_bn,$reshipinfo,$change_total_amount,$is_archive);
                    $reshipLib->createRefund($refund_sdf,$orders); //退款申请完成，并产生退款单
                }
                $pay_money = $change_total_amount;
            }
            //新订单改为已或者部分支付状态
            if ($neworderid) {
                $order = array(
                        'order_id'        => $neworderid,
                        'shop_id'         => $reshipinfo['shop_id'],
                        'pay_status'      => $pay_status,
                        'pay_money'       => $pay_money,
                        'currency'        => 'CNY',
                        'reship_order_bn' => $orders['order_bn'],
                );
                if ($is_archive){
                    $order['archive'] = '1';
                }
                $reshipLib->payChangeOrder($order);
            }
        }elseif($reshipinfo['return_type'] =='return'){ //退货
            $refundMoney  = (float)$reshipinfo['tmoney']; # 退款金额
            if($totalmoney == 0) { //前有节点已经拦掉生成退款申请单
            }elseif($refundMoney>$totalmoney) {
               //多退 退换货生成的退款申请单，退换货单号为:201301251613000368。应退金额(12)扣除折旧费邮费后，实际应退金额为(2)
              $memo = $refund_sdf['memo'].'应退金额('.$refundMoney.')扣除折旧费邮费后，实际应退金额为('.$totalmoney.')';
              $oRefund_apply->update(array("money"=>$totalmoney,"memo"=>$memo),array('refund_apply_bn'=>$refund_apply_bn));
              $is_generate_aftersale = false;
            }elseif($totalmoney>0 && $totalmoney>$refundMoney){
                //少退的
                $memo = $refund_sdf['memo'].'应退商品金额('.$refundMoney.'),';
                if ($reshipinfo['cost_freight_money'] < 0) {
                    $memo .= '加上相应的邮费,';
                }
                $memo .= '实际应退金额为('.$totalmoney.')';
                $oRefund_apply->update(array("money"=>$totalmoney,"memo"=>$memo),array('refund_apply_bn'=>$refund_apply_bn));
                $is_generate_aftersale = false;
            }
        }
        //更新为完成
        $this->update(array('is_check'=>'7','t_end'=>time()),array('reship_id'=>$reship_id));
        $memo .= '操作完成。';
        if($reshipinfo['return_id']){
            $Oreturn_products->update(array('status'=>'4','money'=>$totalmoney),array('return_id'=>$reshipinfo['return_id']));
            $oOperation_log->write_log('return@ome',$reshipinfo['return_id'],$memo);
            //退货完成回写
            if ($change_order_sdf) {
                $newmemo =' 生成了1张换货订单【'.$change_order_sdf['order_bn'].'】';
            }
            kernel::single('ome_service_aftersale')->update_status($reshipinfo['return_id'],'','async',$newmemo);
        }
        $oOperation_log->write_log('reship@ome',$reship_id,$memo);

        //生成售后单
        if($is_generate_aftersale){
         kernel::single('sales_aftersale')->generate_aftersale($reship_id,$reshipinfo['return_type']);
        }

        //售后处理完成的时候，推AG退货入库的标
        $refundOriginalObj = app::get('ome')->model('return_product_tmall');
        $refundOriginalInfo = $refundOriginalObj->getList('refund_fee,jsrefund_flag', array('return_id'=> $reshipinfo['return_id']) , 0 , 1);
        $original_refund_fee = $refundOriginalInfo[0]['refund_fee'];

        $aliag_status = app::get('ome')->getConf('shop.aliag.config.'.$shop_id);
        if($aliag_status && $refund_sdf['shop_type'] == 'tmall' && ($reshipinfo['return_type'] == 'return') && (round($original_refund_fee,3)== round($totalmoney,3)) && $orders['source'] == 'matrix'){
            //识别是否开启AG并且是天猫退货退款已入库的，通知AG
            $compare_nums = $oReship_items->db->select("SELECT item_id FROM sdb_ome_reship_items WHERE reship_id=".$reship_id." AND return_type='return' AND num!=defective_num+normal_num");
            if(!$compare_nums){
                $params = array(
                    'order_bn' => $orders['order_bn'],
                    'apply_id' => $refund_sdf['apply_id'],
                    'refund_bn' => $reshipinfo['reship_bn'],
                    'return_bn' => $reshipinfo['reship_bn'],
                    'is_aftersale_refund' => true,
                    'shop_id' => $shop_id,
                );

                kernel::single('ome_service_refund')->refund_request($params);
            }

        }

        //判断如果是极速退款自动完成退款单
        if ($refundOriginalInfo[0]['jsrefund_flag'] == 'true' && $totalmoney>0 && $reshipinfo['return_type'] == 'return'){
          $this->__jsRefundAuto($refund_sdf);
        }
        return true;
    }

    //退换货单创建 API执行
    public function request_reship_creat_api($shop_id,$reship_id){
        $oShop = $this->app->model('shop');
        $shop_type = $oShop->getRow(array('shop_id'=>$shop_id),'node_type');
        $c2c_shop_type = ome_shop_type::shop_list();
        if(!empty($shop_type['node_type']) && !in_array($shop_type['node_type'],$c2c_shop_type)){
            foreach(kernel::servicelist('service.reship') as $object=>$instance){
                if(method_exists($instance,'reship')){
                    $instance->reship($reship_id);
                }
            }
        }
    }

    //订单明细退货处理 并返回orders数组
    public function do_order_items_return($reshipinfo,$is_archive){
        $oReship_items = $this->app->model('reship_items');
        $Reshipitem = $oReship_items->getList('bn,num,normal_num,defective_num',array('reship_id'=>$reshipinfo["reship_id"],'return_type'=>'return'));
        if ($is_archive) {
            $archive_ordobj = kernel::single('archive_interface_orders');
            $orders = $archive_ordobj->getOrders(array('order_id'=>$reshipinfo['order_id']),'*');
            kernel::single('archive_reship')->finish_aftersale($Reshipitem,$reshipinfo['order_id']);
        }else{
            $oItemModel = $this->app->model('order_items');
            $oOrder = $this->app->model('orders');
            foreach($Reshipitem as $k=>$v){
                $itemsql = "SELECT sendnum,bn,item_id, return_num FROM sdb_ome_order_items WHERE order_id='".$reshipinfo['order_id']."' AND bn='".$v['bn']."' AND sendnum != return_num AND `delete`='false'";
                $orderItems = $this->db->select($itemsql);
                $num = intval($v['normal_num']+$v['defective_num']);
                $residue_num    = 0;//剩余退货量 ExBOY
                foreach ($orderItems as $ivalue) {
                    if($num <= 0) break;
                    $residue_num    = intval($ivalue['sendnum'] -  $ivalue['return_num']);//剩余数量=已发货量-已退货量 ExBOY
                    if ($num > $residue_num) {
                        $num -= $residue_num;
                        #更新_已退货量 = 已发货量 ExBOY
                        $oItemModel->update(array('return_num' => $ivalue['sendnum']),array('item_id'=>$ivalue['item_id']));
                    } else {
                        #更新_已退货量 = 已退货量 + 本次退货量 ExBOY
                        $oItemModel->update(array('return_num' => ($ivalue['return_num'] + $num)),array('item_id'=>$ivalue['item_id']));
                    }
                }
            }
            //更新订单发货状态[return_num排除_已退完商品 ExBOY]
            $order_sum = $this->db->selectrow("SELECT sum(sendnum) as count FROM sdb_ome_order_items WHERE order_id='".$reshipinfo['order_id']."' AND sendnum != return_num AND `delete`='false'");
            //拆单_部分发货_部分退货时_判断是否有未发货的货品 ExBOY
            $orders = $oOrder->dump(array('order_id'=>$reshipinfo['order_id']));
            if(intval($order_sum['count']) == 0){
                if($orders['ship_status'] == '2' || $orders['ship_status'] == '3'){
                    $sql    = "SELECT sum(nums - sendnum) as count FROM sdb_ome_order_items WHERE order_id = '".$reshipinfo['order_id']."' AND nums != sendnum AND `delete` = 'false'";
                    $order_sum    = $this->db->selectrow($sql);
                }
            }
            $ship_status = (intval($order_sum['count']) == 0) ? '4' : '3';
            $oOrder->update(array('ship_status'=>$ship_status),array('order_id'=>$reshipinfo['order_id']));
            $orders['ship_status'] = $ship_status;#更新后的_发货状态 ExBOY
        }
        return $orders;
    }

    /*
     * 生成退款申请单
     * $refund_apply_bn 生成的退款申请单号
     * $reshipinfo array 退换货单信息
     * $money 申请退款金额
     * $is_archive 是否归档
     */
    public function create_refund_apply_record($refund_apply_bn,$reshipinfo,$money,$is_archive){

        //退款明细序列化字段
        $addon    = array('reship_id'=>$reshipinfo["reship_id"],'return_id'=>$reshipinfo['return_id']);

        //组保存数据
        $refund_sdf = array(
            'refund_refer' => '1',
            'order_id' => $reshipinfo['order_id'],
            'refund_apply_bn' => $refund_apply_bn,
            'pay_type' => 'online',
            'money' => (float)$money,
            'refunded' => 0,
            'memo' => '退换货生成的退款申请单，退换货单号为:'.$reshipinfo['reship_bn'].'。',
            'status' => 0,
            'shop_id' => $reshipinfo['shop_id'],
            'addon' => serialize($addon),
            'return_id' => $reshipinfo['return_id'],
            'bcmoney' => (float)$reshipinfo['bcmoney'],
        );

        if ($is_archive) {
            $refund_sdf['archive'] = '1';
            $refund_sdf['source'] = 'archive';
        }
        else
        {
            $refund_sdf['source']    = 'local';
        }

        //创建退款申请单
        $is_update_order    = false;//是否更新订单付款状态
        kernel::single('ome_refund_apply')->createRefundApply($refund_sdf, $is_update_order, $error_msg);

        return $refund_sdf;
    }

    function io_title( $filter=null,$ioType='csv' ){

        switch( $ioType ){
            case 'csv':
            default:
                $this->oSchema['csv']['reship'] = array(
                    'col:退换货单号' => 'reship_bn',
                    'col:售后申请单号' => 'return_id',
                    'col:售后申请标题' => 'return_title',
                    'col:问题类型'=>'problem_id',
                    'col:订单号' => 'order_id',
                    'col:配送费用' => 'money',
                    'col:是否保价' => 'is_protect',
                    'col:配送方式' => 'delivery',
                    'col:物流公司名称' => 'logi_name',
                    'col:物流单号' => 'logi_no',
                    'col:退回物流公司名称' => 'return_logi_name',
                    'col:退回物流单号' => 'return_logi_no',
                    'col:收货人姓名' => 'ship_name',
                    'col:收货人地区' => 'ship_area',
                    'col:收货人地址' => 'ship_addr',
                    'col:收货人邮编' => 'ship_zip',
                    'col:收货人电话' => 'ship_tel',
                    'col:收货人手机' => 'ship_mobile',
                    'col:收货人Email' => 'ship_email',
                    'col:当前状态' => 'is_check',
                    'col:备注' => 'memo',
                    'col:退款的金额' => 'tmoney',
                    'col:补差的金额' => 'bmoney',
                    'col:补偿费用' => 'bcmoney',
                    'col:最后合计金额' => 'totalmoney',
                    'col:收货时间'=>'receive_time',
                    'col:单据结束时间'=>'t_end',
                );


                    $this->oSchema['csv']['items'] = array(
                    'col:退货单号' => 'reship_bn',
                    'col:商品货号' => 'bn',
                    'col:仓库名称' => 'branch_name',
                    'col:类型' => 'return_type',
                    'col:商品名称' => 'product_name',
                    'col:申请数量' => 'num',
                    'col:良品' => 'normal_num',
                    'col:不良品' =>'defective_num',

                );
                    break;
        }
        if($this->expert_flag){
           $_title = array(
                    'col: 售后类型' => 'return_type',
                    'col:单据创建时间' => 't_begin',
                   );
           $this->oSchema[$ioType]['reship'] = array_merge($this->oSchema[$ioType]['reship'],$_title);
        }

        $this->ioTitle[$ioType][$filter] = array_keys( $this->oSchema[$ioType][$filter] );
        return $this->ioTitle[$ioType][$filter];
     }

     //csv导出
     function fgetlist_csv( &$data,$filter,$offset,$exportType = 1 ){
        $this->expert_flag =true;

        if( !$data['title']['reship'] ){
            $title = array();
            foreach( $this->io_title('reship') as $k => $v ){
                $title[] = $this->charset->utf2local($v);
            }
            $data['title']['reship'] = '"'.implode('","',$title).'"';
        }
        if( !$data['title']['items'] ){
            $title = array();
            foreach( $this->io_title('items') as $k => $v )
                $title[] = $this->charset->utf2local($v);
            $data['title']['items'] = '"'.implode('","',$title).'"';
        }
        $limit = 100;

        $itemsObj = $this->app->model('reship_items');
        if( !$list=$this->getList('reship_id',$filter,$offset*$limit,$limit) )return false;
        $oProduct_pro   = $this->app->model('return_process');
        foreach( $list as $aFilter ){
            $aReship = $this->dump($aFilter['reship_id'],'reship_bn,return_id,problem_id,order_id,money,is_protect,delivery,logi_name,logi_no,return_logi_name,return_logi_no,ship_name,ship_area,ship_addr,ship_zip,ship_tel,ship_mobile,ship_email,is_check,memo,tmoney,bmoney,totalmoney,return_type,bcmoney,t_end,t_begin');

            $reship_id = $aFilter['reship_id'];
            $return_process = $oProduct_pro->dump(array('reship_id'=>$reship_id),'process_data');

            $aReship['return_logi_no'] = "=\"\"".$aReship['return_logi_no']."\"\"";
            $aReship['logi_no'] = "=\"\"".$aReship['logi_no']."\"\"";
            $aReship['reship_bn'] =  "=\"\"".$aReship['reship_bn']."\"\"";//$aReship['reship_bn']."\t";
            //处理售后信息
            $rp = $this->app->model('return_product')->dump($aReship['return_id'],'return_bn,title');
            $aReship['return_id'] = "=\"\"".strval($rp['return_bn'])."\"\"";//strval($rp['return_bn'])."\t";
            $aReship['return_title'] = $rp['title'];

            #售后类型
            if($aReship['return_type']){
                $aReship['return_type'] = $this->return_type[$aReship['return_type']];
            }
            //售后问题
            $rpp = $this->app->model('return_product_problem')->dump($aReship['problem_id'],'problem_name');
            $aReship['problem_id'] = $rpp['problem_name'];
            if ($aReship['archive'] == '1') {
                //处理订单号
                $archive_ordObj = kernel::single('archive_interface_orders');

                $oOrder = $archive_ordObj->getOrders(array('order_id'=>$aReship['order_id']),'order_bn');
            }else{
                //处理订单号
                $oOrder = $this->app->model('orders')->dump($aReship['order_id']);
            }
            $aReship['order_id'] = "=\"\"".$oOrder['order_bn']."\"\"";//$oOrder['order_bn']."\t";

            //处理物流信息
            $dc = $this->app->model('dly_corp')->dump($aReship['return_logi_name'],'name');
            $aReship['return_logi_name'] = $dc['name'];
            //
            $process_data = $return_process['process_data'];
            $aReship['receive_time'] = '';
            $aReship['t_begin'] = $aReship['t_begin'] ? date('Y-m-d H:i:s',$aReship['t_begin']) : '';
            $aReship['t_end'] = $aReship['t_end'] ? date('Y-m-d H:i:s',$aReship['t_end']) : '';
            if ($process_data) {
                $process_data = unserialize($process_data);
                $aReship['receive_time'] = date('Y-m-d H:i:s',$process_data['shiptime']);
            }

            //处理收货地区
            $rd = explode(':', $aReship['ship_area']);
            if($rd[1]){
             $aReship['ship_area'] = str_replace('/', '-', $rd[1]);
            }

            //处理当前状态
            $aReship['is_check'] = $this->is_check[$aReship['is_check']];

            $aReship['is_protect'] = $aReship['is_protect']=='false'?'否':'是';


            $oreship = array_values($this->oSchema['csv']['reship']);
            //items
            $_items = $itemsObj->getlist('*',array('reship_id'=>$reship_id));

            foreach ( $_items as $_k=>$_v ) {
                $itemcsv =array_values($this->oSchema['csv']['items']);
                switch ($_v['return_type']) {
                    case 'return':
                         $return_type = '退货';
                        break;
                    case 'change':
                        $return_type = '换货';
                        break;
                        case 'refuse':
                            $return_type = '拒收退货';
                            break;

                }
                $branch = $itemsObj->db->selectrow("SELECT name FROM sdb_ome_branch WHERE branch_id=".$_v['branch_id']);
                $item = array(
                    'reship_bn'=>$aReship['reship_bn'],
                    'bn'=>$_v['bn'],
                    'product_name'=>$_v['product_name'],
                    'num'=>$_v['num'],
                    'normal_num'=>$_v['normal_num'],
                    'defective_num'=>$_v['defective_num'],
                    'return_type'=>$return_type,
                    'branch_name'=>$branch['name'],
                );

               foreach ($itemcsv as $ik=>$iv ) {
                   $itemRow[$ik] = $this->charset->utf2local($item[$iv]);
               }
               $data['content']['items'][] = '"'.implode('","',$itemRow).'"';
               unset($branch);
            }
            foreach( $oreship as $k=>$v ){
                $reshipRow[$v] = $this->charset->utf2local($aReship[$v]);
            }
            $data['content']['reship'][] = '"'.implode('","',$reshipRow).'"';
        }

        $data['name'] = '退换货单'.date("Ymd");

        return true;
    }

    public function getexportdetail($fields,$filter,$offset=0,$limit=1,$has_title=false)
    {

        $reship_arr = $this->getList('reship_bn,reship_id', array('reship_id' => $filter['reship_id']), 0, -1);
        foreach ($reship_arr as $reship) {
            $reship_bn[$reship['reship_id']] = $reship['reship_bn'];
        }

        $Obranch = app::get('ome')->model('branch');
        $branchs = $Obranch->getList('branch_id,name');
        foreach ($branchs as $v) {
            $branch[$v['branch_id']] = $v['name'];
        }
        unset($branchs);

        $reshipItemsObj = app::get('ome')->model('reship_items');
        $reship_items_arr = $reshipItemsObj->getList('*',array('reship_id'=>$filter['reship_id']));
        $row_num = 1;
        if($reship_items_arr){
            foreach ($reship_items_arr as $key => $reship_item) {
                $reshipItemRow['*:销售单号']   = isset($reship_bn[$reship_item['reship_id']]) ? mb_convert_encoding($reship_bn[$reship_item['reship_id']], 'GBK', 'UTF-8') : '-';
                $reshipItemRow['*:商品货号']       = mb_convert_encoding($reship_item['bn'], 'GBK', 'UTF-8');
                $reshipItemRow['*:仓库名称']       = isset($branch[$reship_item['branch_id']]) ? mb_convert_encoding($branch[$reship_item['branch_id']], 'GBK', 'UTF-8') : '-';

                switch ($reship_item['return_type']) {
                    case 'return':
                         $return_type = '退货';
                        break;
                    case 'change':
                        $return_type = '换货';
                        break;
                    case 'refuse':
                        $return_type = '拒收退货';
                        break;
                }

                $reshipItemRow['*:类型']   = mb_convert_encoding($return_type, 'GBK', 'UTF-8');
                $reshipItemRow['*:商品名称']   = mb_convert_encoding($reship_item['product_name'], 'GBK', 'UTF-8');
                $reshipItemRow['*:申请数量']   = $reship_item['num'];
                $reshipItemRow['*:良品']   = $reship_item['normal_num'];
                $reshipItemRow['*:不良品']   = $reship_item['defective_num'];

                $data[$row_num] = implode(',', $reshipItemRow);
                $row_num++;
            }
        }

        //明细标题处理
        if($data && $has_title){
            $title = array(
                '*:退货单号',
                '*:商品货号',
                '*:仓库名称',
                '*:类型',
                '*:商品名称',
                '*:申请数量',
                '*:良品',
                '*:不良品',
            );

            foreach ((array)$title as $key => $value) {
                $title[$key] = mb_convert_encoding($value, 'GBK', 'UTF-8');
            }

            $data[0] = implode(',', $title);
        }

        ksort($data);
        return $data;
    }

    function export_csv($data,$exportType = 1 ){

        $output = array();
            foreach( $data['title'] as $k => $val ){
                $output[] = $val."\n".implode("\n",(array)$data['content'][$k]);
            }
        echo implode("\n",$output);
    }

    function getLogiInfo($logi_no,$branch_ids=array()){
        $sql = 'select reship_id from sdb_ome_reship where return_logi_no="'.$logi_no.'"';
        if ($branch_ids) {
            $sql.=" AND branch_id in (".implode(',',$branch_ids).")";
        }
      $loginfo = $this->db->selectrow($sql);
      if($loginfo['reship_id']){
          return $loginfo['reship_id'];
      }
        return false;
    }

    public function modifier_totalmoney($row)
    {
        $cur = app::get('eccommon')->model('currency');
        if ($row<0) {
            $c = $cur->changer(-1*$row);
            $row = '还需用户补款:<span style="color:#3333ff;">'.$c.'</span>';
        }else{
            $c = $cur->changer($row);
            $row = '需退还用户:<span style="color:red;">'.$c.'</span>';
        }

        return $row;
    }

    public function modifier_is_check($row) {
        if($row == '3') {
            return '审核成功';
        }
        return $this->schema['columns']['is_check']['type'][$row];
    }

    public function modifier_op_id($row){
        switch ($row) {

            case 16777215:
                $ret = '系统';
                break;
            default:
                $ret = $this->_getUserName($row);
                break;
        }

        return $ret;
    }

    /**
     * 获取用户名
     *
     * @param Integer $gid
     * @return String;
     */
    private function _getUserName($uid) {
        if (self::$__USERS === null) {

            self::$__USERS = array();
            $rows = app::get('desktop')->model('users')->getList('*');
            foreach((array) $rows as $row) {
                self::$__USERS[$row['user_id']] = $row['name'];
            }
        }

        if (isset(self::$__USERS[$uid])) {

            return self::$__USERS[$uid];
        } else {

            return '系统';
        }
    }
    /**
     * 获得日志类型(non-PHPdoc)
     * @see dbeav_model::getLogType()
     */
    public function getLogType($logParams) {
        $type = $logParams['type'];
        $logType = 'none';
        if ($type == 'export') {
            $logType = $this->exportLogType($logParams);
        }
        elseif ($type == 'import') {
            $logType = $this->importLogType($logParams);
        }
        return $logType;
    }
    /**
     * 导出日志类型
     * @param Array $logParams 日志参数
     */
    public function exportLogType($logParams) {
        $params = $logParams['params'];
        $type = 'afterSale';
        if ($logParams['app'] == 'ome' && $logParams['ctl'] == 'admin_return_rchange') {
            if (isset($params['is_check'])) {
                //质检单据
                $type .= '_exchange_goods_qualityTesting';
            }
            else {
                //退换货
                $type .= '_exchange_goods_exchangeList';
            }
        }
        $type .= '_export';
        return $type;
    }
    /**
     * 导入操作日志类型
     * @param Array $logParams 日志参数
     */
    public function importLogType($logParams) {
        $params = $logParams['params'];
        $type = 'afterSale';
        $type .= '_import';
        return $type;
    }


    /**
     * 补偿费用显示
     * @param int
     * @return
     * @access  public
     * @author cyyr24@sina.cn
     */
    function modifier_bcmoney($row)
    {
        if ($row>0) {
            $bcmoney = sprintf("<div style='background-color:%s;float:left;'><span alt='%s' title='%s' style='color:#eeeeee;'>&nbsp;%s&nbsp;</span></div>", 'red', $row, $row, $row);
            return $bcmoney;
        }
    }

    public function disabled_export_cols(&$cols){
        unset($cols['column_edit']);
    }

    /**
     * 单据来源.
     * @param   type    $varname    description
     * @return  type    description
     * @access  public
     * @author cyyr24@sina.cn
     */
    function modifier_source($row)
    {

        if($row == 'archive'){
           $row = sprintf("<div style='background-color:%s;float:left;'><span alt='%s' title='%s' style='color:#eeeeee;'>&nbsp;%s&nbsp;</span></div>", 'red', '归档', '归档', '归档');
        }else{
            $row = '-';
        }
        return $row;
    }


    /**
     * 删除换货明细.
     * @param
     * @return
     * @access  public
     * @author
     */
    function _deletechange_item($reship_id,$change,$oldchange)
    {
        $newid =$this->_map_itemid($change['objects']);
        $oldid = $this->_map_itemid($oldchange);

        $diff = array();
        foreach ($oldid as $k=>$v ) {
            $diff[$k] = array_udiff_assoc((array)$v, (array)$newid[$k],array($this,'comp_array_value'));
        }

        #根据obj_id删除不需要的数据
        $db = kernel::database();
        foreach ((array)$diff as $dk=>$delitem ) {
            if ($delitem) {
                foreach ($delitem as $dv )
                {
                    #先删除销售物料再删除对应的基础物料数据
                    $db->exec("DELETE FROM sdb_ome_reship_objects WHERE reship_id=".$reship_id." AND obj_id=".$dv);
                    $db->exec("DELETE FROM sdb_ome_reship_items WHERE reship_id=".$reship_id." AND obj_id=".$dv);
                }
            }
        }

        return $diff;
    }

    public function _map_itemid($change){
        if (empty($change)){
            return array();
        }
        $ids = array();
        foreach ($change as $v ) {
            if ($v['item_id']) {
                $ids[$v['item_type']][] =$v['item_id'];
            }
        }
        return $ids;
    }

    public function comp_array_value($a,$b)
    {
        if ($a == $b) {
            return 0;
        }

        return $a > $b ? 1 : -1 ;
    }

    function getSalepriceByorderId($order_id){
        $items = $this->db->select("SELECT bn,sales_amount FROM sdb_ome_sales_items AS I LEFT JOIN sdb_ome_sales as S ON I.sale_id=S.sale_id WHERE S.order_id=".$order_id." AND I.product_id>0");

        $data = array();
        foreach ( $items as $item ){
            $data[$item['bn']] = $item['sales_amount'];
        }

        return $data;

    }

    public function __jsRefundAuto($refund_sdf){

      $orderObj = app::get('ome')->model('orders');
      $order_detail = $orderObj->dump(array('order_id'=>$refund_sdf['order_id']),'payed');

      if ($order_detail['payed']>=$refund_sdf['money']){
        $data = array(
            'refund_bn'     => $refund_sdf['refund_apply_bn'],
            'shop_id'       => $refund_sdf['shop_id'],
            'order_id'      => $refund_sdf['order_id'],
            'currency'      => 'CNY',
            'money'         => $refund_sdf['money'],
            'cur_money'     => $refund_sdf['money'],
            'pay_type'      => $refund_sdf['pay_type'],
            'download_time' => time(),
            'status'        => 'succ',
            'memo'          => $refund_sdf['memo'],
            'trade_no'      => $refund_sdf['alipay_no'],
            'modifiey'      => $refund_sdf['modified'],
            'payment'       => $refund_sdf['payment'],
            't_ready'       => time(),
            't_sent'        => time(),

        );
        $rs = app::get('ome')->model('refunds')->insert($data);
        if($rs){
            $applyObj = app::get('ome')->model('refund_apply');

            $updateData = array('status' => '4','refunded' => $data['money']);
            $filter = array('apply_id' => $refund_sdf['apply_id']);
            app::get('ome')->model('refund_apply')->update($updateData,$filter);

            app::get('ome')->model('operation_log')->write_log('refund_apply@ome', $refund_sdf['apply_id'], '极速:退款成功');

            $sql ="update sdb_ome_orders set payed=IF((CAST(payed AS char)-IFNULL(0,cost_payment)-".$data['money'].")>=0,payed-IFNULL(0,cost_payment)-".$data['money'].",0)  where order_id=".$refund_sdf['order_id'];
            kernel::database()->exec($sql);
            kernel::single('ome_order_func')->update_order_pay_status($refund_sdf['order_id']);

            //生成售后单
            kernel::single('sales_aftersale')->generate_aftersale($refund_sdf['apply_id'],'refund');

            $pReturnModel = $this->app->model('return_product');
            $pReturnModel->update(array('refundmoney'=>$refund_sdf['money']),array('return_id'=>$refund_sdf['return_id']));
        }

      }

    }
}
?>
