<?php
/**
 * 根据传入的域名做初始化工作
 * 
 * @author hzjsq@msn.com
 * @version 1.0
 */

$domain = $argv[1];
$order_id = $argv[2];
$host_id = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id)) {

	die('No Params');
}

set_time_limit(0);

require_once(dirname(__FILE__) . '/../../lib/init.php');

cachemgr::init(false);

$productSerialObj = app::get('ome')->model('product_serial');
$count = $productSerialObj->count();
if($count <= 0){
    die('no serial info');
}


$db     = kernel::database();
//check if has unfinished bill
$sql = "SELECT d.delivery_id FROM sdb_ome_delivery_items AS di 
                LEFT JOIN sdb_ome_delivery AS d ON d.delivery_id = di.delivery_id 
                LEFT JOIN sdb_material_basic_material AS bm ON bm.bm_id = di.product_id 
                WHERE (d.parent_id=0 OR d.is_bind='true') AND d.status IN('progress','ready','stop') AND bm.serial_number ='true'";

$dataList = $db->select($sql);
if($dataList){
    die('has unfinished delivery');
}

$sql2 = "SELECT r.reship_id FROM sdb_ome_reship_items AS ri 
                LEFT JOIN sdb_ome_reship AS r ON r.reship_id = ri.reship_id 
                LEFT JOIN sdb_material_basic_material AS bm ON bm.bm_id = ri.product_id 
                WHERE r.is_check in('0','1','2','6','8','9','10','11') AND bm.serial_number ='true'";

$dataList2 = $db->select($sql2);
if($dataList2){
    die('has unfinished aftersales');
}

$offset = 0;

while(update_serial($offset)){
	$offset++;
}


function update_serial($offset){
    $limit = 500;
    $start = $offset*$limit;

    $productSerialObj = app::get('ome')->model('product_serial');
    $serialLogObj = app::get('ome')->model('product_serial_log');
    $wmsPrdSerialObj = app::get('wms')->model('product_serial');
    $prdSerialHistoryObj    = app::get('ome')->model('product_serial_history');
    $omeDlyObj = app::get('ome')->model('delivery');
    $wmsDlyObj = app::get('wms')->model('delivery');
    $returnProcessObj = app::get('ome')->model('return_process');
    $reshipObj = app::get('ome')->model('reship');
    $omeDlyItemsSerialObj    = app::get('ome')->model('delivery_items_serial');
    $wmsDlyItemsSerialObj    = app::get('wms')->model('delivery_items_serial');
    $dlyItemsSerialLib    = kernel::single('wms_receipt_dlyitemsserial');

    //$item_ids = array();
    $prdSerialInfo = $productSerialObj->getList('*', array(), $start, $limit);
    if($prdSerialInfo){
        foreach($prdSerialInfo as $prdSerial){
            //$item_ids[] = $prdSerial['item_id'];
            $basicMaterialObj = app::get('material')->model('basic_material');
            $basicMaterialInfo = $basicMaterialObj->dump(array('material_bn' => $prdSerial['bn']),'material_name');
            if($basicMaterialInfo){
                $prdSerial['product_name'] = $basicMaterialInfo['material_name'];
            }

            //save serial info
            $saveData = array(
                'branch_id' => $prdSerial['branch_id'],
                'product_id' => $prdSerial['product_id'],
                'bn' => $prdSerial['bn'],
                'serial_number' => $prdSerial['serial_number'],
                'status' => $prdSerial['status'], //0入库 1出库 2无效作废
                'create_time' => time(),
                'update_time' => time(),
            );
            $wmsPrdSerialObj->save($saveData);

            $serial_id = $saveData['serial_id'];
            unset($saveData);

            //transform history row
            $logInfo = $serialLogObj->getList('*', array('item_id' => $prdSerial['item_id']), 0, -1);
            if($logInfo){
                foreach($logInfo as $log){
                    if($log['act_type'] == 0){
                        $dlyInfo = $wmsDlyObj->dump($log['bill_no'],'outer_delivery_bn');

                        //sale out
                        $saleData = array(
                            'branch_id' => $prdSerial['branch_id'],
                            'product_id' => $prdSerial['product_id'],
                            'bn' => $prdSerial['bn'],
                            'product_name' => $prdSerial['product_name'],
                            'act_type' => '1',
                            'act_time' => $log['act_time'],
                            'act_owner' => $log['act_owner'],
                            'bill_type' => '1',
                            'bill_no' => $dlyInfo['outer_delivery_bn'],
                            'serial_number' => $prdSerial['serial_number'],
                        );
                        $prdSerialHistoryObj->save($saleData);
                        unset($saleData);

                        //wms row
                        $wmsRow = array(
                            'delivery_id' => $log['bill_no'],
                            'product_id' => $prdSerial['product_id'],
                            'bn' => $prdSerial['bn'],
                            'product_name' => $prdSerial['product_name'],
                            'serial_id' => $serial_id,
                            'status' => '1',
                            'serial_number' => $prdSerial['serial_number'],
                        );
                        $wmsDlyItemsSerialObj->save($wmsRow);
                        unset($wmsRow);

                        $omedlyInfo = $omeDlyObj->dump(array('delivery_bn' => $dlyInfo['outer_delivery_bn']),'delivery_id');
                        //ome row
                        $omeRow = array(
                            'delivery_id' => $omedlyInfo['delivery_id'],
                            'product_id' => $prdSerial['product_id'],
                            'bn' => $prdSerial['bn'],
                            'product_name' => $prdSerial['product_name'],
                            'status' => '1',
                            'serial_number' => $prdSerial['serial_number'],
                        );
                        $omeDlyItemsSerialObj->save($omeRow);
                        unset($omeRow);

                    }elseif($log['act_type'] == 1){
                        $returnProcessInfo = $returnProcessObj->dump($log['bill_no'],'reship_id');
                        $reshipInfo = $reshipObj->dump($returnProcessInfo['reship_id'],'reship_bn');
                        
                        //return in
                        $returnData = array(
                            'branch_id' => $prdSerial['branch_id'],
                            'product_id' => $prdSerial['product_id'],
                            'bn' => $prdSerial['bn'],
                            'product_name' => $prdSerial['product_name'],
                            'act_type' => '2',
                            'act_time' => $log['act_time'],
                            'act_owner' => $log['act_owner'],
                            'bill_type' => '2',
                            'bill_no' => $reshipInfo['reship_bn'],
                            'serial_number' => $prdSerial['serial_number'],
                        );
                        $prdSerialHistoryObj->save($returnData);
                        unset($returnData);

                        //ome row
                        $serialItem = array(
                            'serial_number' => $serial_number,
                            'reship_id' => $returnProcessInfo['reship_id'],
                            'reship_bn' => $reshipInfo['reship_bn'],
                            'branch_id' => $prdSerial['branch_id'],
                            'bn' => $prdSerial['bn'],
                        );
                        $rs = $dlyItemsSerialLib->returnProduct($serialItem, $err_msg, $return_serial);
                    }
                }
            }
        }
        return true;
    }else{
        return false;
    }
}
